searchNodes=[{"doc":"Numbers are assigned such that a path can be traced around the tree, taking in every node. The path here starts at root , flowing down the left, around the bottom of the b subtree, then up to the e branch of a , and from there to the other branches of root , before flowing back to root . Leaf nodes (those with no children) have Left and Right values immediately after each other; f , for example, is 11/12. The parent of a node has a smaller Left and a bigger Right; which can be used to trace up the tree finding parent nodes, until you hit a Left of 0 (meaning the root node). MPTree API Constructors from_node/1 Reducers insert/3 insert!/3 update_nodes/2 update_nodes/3 Converters fetch_ancestors_and_self/2 fetch_ancestors_and_self!/2 fetch_children/2 fetch_children!/2 fetch_descendents/2 fetch_descendents!/2 fetch_family_tree/2 fetch_family_tree!/2 fetch_node/2 fetch_node!/2 fetch_parent/2 fetch_parent!/2 fetch_transition_path/3 fetch_transition_path!/3 nodes/1","ref":"MPTree.html","title":"MPTree","type":"module"},{"doc":"Return ancestors of and the node itself matching descendent_fn . In this example, the blue (ancestor) and red (matched) nodes are returned. Returns :error if no node is found.","ref":"MPTree.html#fetch_ancestors_and_self/2","title":"MPTree.fetch_ancestors_and_self/2","type":"function"},{"doc":"Return ancestors of and the node itself matching descendent_fn . Throws if no node is found.","ref":"MPTree.html#fetch_ancestors_and_self!/2","title":"MPTree.fetch_ancestors_and_self!/2","type":"function"},{"doc":"Find children of the node matching parent_fn In this example, the red node matches, and the blue nodes are returned [ b , e ] Returns :error if no parent is found.","ref":"MPTree.html#fetch_children/2","title":"MPTree.fetch_children/2","type":"function"},{"doc":"Find children of the node matching parent_fn . Throws if no parent is found.","ref":"MPTree.html#fetch_children!/2","title":"MPTree.fetch_children!/2","type":"function"},{"doc":"Find descendents of the node matching ancestor_fn . In this example, diagram, the blue (descendent) nodes are returned. The red (matched) node is not returned. Returns :error if no ancestor is found.","ref":"MPTree.html#fetch_descendents/2","title":"MPTree.fetch_descendents/2","type":"function"},{"doc":"Find descendents of the node matching ancestor_fn . Throws if no ancestor is found.","ref":"MPTree.html#fetch_descendents!/2","title":"MPTree.fetch_descendents!/2","type":"function"},{"doc":"Find all ancestors and descendents of the node matching match_fn . In the below diagram, the red (matched node) and blue (ancestor and descendent) nodes are returned. Returns :error if node is not found.","ref":"MPTree.html#fetch_family_tree/2","title":"MPTree.fetch_family_tree/2","type":"function"},{"doc":"Find all ancestors and descendents of the node matching match_fn . Throws if node is not found.","ref":"MPTree.html#fetch_family_tree!/2","title":"MPTree.fetch_family_tree!/2","type":"function"},{"doc":"Return the first node matching match_fn . In this example, the red and blue nodes would all match, but only the red is returned Returns :error if no node is found.","ref":"MPTree.html#fetch_node/2","title":"MPTree.fetch_node/2","type":"function"},{"doc":"Return the first node matching match_fn . Throws if no node is found.","ref":"MPTree.html#fetch_node!/2","title":"MPTree.fetch_node!/2","type":"function"},{"doc":"Find parent of the node matching child_fn . In this example, the blue (parent) node is returned. Returns :error if child is not found or if child is the root node.","ref":"MPTree.html#fetch_parent/2","title":"MPTree.fetch_parent/2","type":"function"},{"doc":"Find parent of the node matching child_fn . Throws if child is not found or if child is the root node.","ref":"MPTree.html#fetch_parent!/2","title":"MPTree.fetch_parent!/2","type":"function"},{"doc":"Get the path from a starting node to an ending node. In this example, the green (starting matched), red (ending matched), and blue (path) nodes are returned in :exit or :enter tuples The above returns [ exit : f , enter : a , enter : b ] Returns :error if no node is found.","ref":"MPTree.html#fetch_transition_path/3","title":"MPTree.fetch_transition_path/3","type":"function"},{"doc":"Get the path from a starting node to an ending node. Throws if no node is found.","ref":"MPTree.html#fetch_transition_path!/3","title":"MPTree.fetch_transition_path!/3","type":"function"},{"doc":"Create a tree from a root_node .","ref":"MPTree.html#from_node/1","title":"MPTree.from_node/1","type":"function"},{"doc":"Insert a node or tree as a new child of the node matching parent_fn . In this example, the green node is about to be inserted. Here is after the insertion. Returns :error if no existing node matches parent_fn","ref":"MPTree.html#insert/3","title":"MPTree.insert/3","type":"function"},{"doc":"Insert a node or tree as a new child of the node matching parent_fn . Throws if no existing node matches parent_fn","ref":"MPTree.html#insert!/3","title":"MPTree.insert!/3","type":"function"},{"doc":"Get all nodes.","ref":"MPTree.html#nodes/1","title":"MPTree.nodes/1","type":"function"},{"doc":"Apply update_fn/0 to all nodes.","ref":"MPTree.html#update_nodes/2","title":"MPTree.update_nodes/2","type":"function"},{"doc":"Apply update_fn/0 to all nodes matching the match_fn/0 .","ref":"MPTree.html#update_nodes/3","title":"MPTree.update_nodes/3","type":"function"},{"doc":"Used by insert , update , and fetch functions to find nodes. Beware, this will match only the first node it finds. If there any many nodes that might possibly pass the test, the results could be unpredictable.","ref":"MPTree.html#t:match_fn/0","title":"MPTree.match_fn/0","type":"type"},{"doc":"","ref":"MPTree.html#t:nodes/0","title":"MPTree.nodes/0","type":"type"},{"doc":"","ref":"MPTree.html#t:t/0","title":"MPTree.t/0","type":"type"},{"doc":"","ref":"MPTree.html#t:transition_path/0","title":"MPTree.transition_path/0","type":"type"},{"doc":"Updates a node","ref":"MPTree.html#t:update_fn/0","title":"MPTree.update_fn/0","type":"type"},{"doc":"A Tree is made of many nodes. Here is one. A valid MPTree node is a map with a :__mptree_node__ key holding a value of meta/0 . Here is the absolute minimal node you can build: my_node = %{ __mptree_node__ : init ( ) } Here's a node implemented as a struct: defmodule MyNode do defstruct [ :name , __mptree_node__ : init ( ) ] @type t :: % __MODULE__ { name : String . t ( ) , __mptree_node__ : MPTree.Node . meta ( ) } new ( name ) , do : % __MODULE__ { name : name } end iex&gt; MyNode . new ( &quot;hello&quot; ) % MyNode { name : &quot;hello&quot; , __mptree_node__ : _ } If you're a fan of the excellent little TypedStruct library, you can just use MPTree.Node as a plugin. The below module compiles to the exact same result as above, but is cleaner, more expressive, and hides more MPTree implementation details. defmodule MyNode do use TypedStruct typedstruct do plugin MPTree.Node field :name , String . t ( ) end new ( name ) , do : % __MODULE__ { name : name } end iex&gt; MyNode . new ( &quot;hello&quot; ) % MyNode { name : &quot;hello&quot; , __mptree_node__ : _ } But it would be easier if you just used the","ref":"MPTree.Node.html","title":"MPTree.Node","type":"module"},{"doc":"When creating your nodes, and before inserting into a tree, ensure it has a :__mptree_node__ key with the value from init/0 assigned to it.","ref":"MPTree.Node.html#init/0","title":"MPTree.Node.init/0","type":"function"},{"doc":"Instantiated by MPTree.Node.init/0 and maintained by MPTree","ref":"MPTree.Node.html#t:meta/0","title":"MPTree.Node.meta/0","type":"opaque"},{"doc":"","ref":"MPTree.Node.html#t:t/0","title":"MPTree.Node.t/0","type":"type"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fixed Remove unused &quot;inspect_opts&quot; variable Added MPTree.fetch_family_tree/2 MPTree.fetch_family_tree!/2 MPTree.fetch_node/2 MPTree.fetch_node!/2 MPTree.fetch_ancestors_and_self/2 MPTree.fetch_ancestors_and_self!/2 MPTree.fetch_transition_path/3 MPTree.fetch_transition_path!/3","ref":"changelog.html#0-2-0-2022-11-07","title":"Changelog - [0.2.0] - 2022-11-07","type":"extras"},{"doc":"Fixed Mix file module name referenced Statechart , the library that MPTree was extracted from.","ref":"changelog.html#0-1-1-2022-10-23","title":"Changelog - 0.1.1 - 2022-10-23","type":"extras"},{"doc":"Added MPTree.from_node/1 MPTree.insert/3 MPTree.insert!/3 MPTree.update_nodes/2 MPTree.update_nodes/3 MPTree.fetch_children/2 MPTree.fetch_children!/2 MPTree.fetch_descendents/2 MPTree.fetch_descendents!/2 MPTree.fetch_parent/2 MPTree.fetch_parent!/2 MPTree.nodes/1","ref":"changelog.html#0-1-0-2022-10-21","title":"Changelog - 0.1.0 - 2022-10-21","type":"extras"}]